'''
Created on 27 févr. 2015

@author: inso
'''

from PyQt5.QtCore import QObject, pyqtSlot, pyqtSignal
from ..person import Person
import logging


class PersonsWatcher(QObject):
    '''
    This will crawl the network to always
    have up to date informations about the nodes
    '''

    person_changed = pyqtSignal(str)
    end_watching = pyqtSignal()

    def __init__(self, community):
        super().__init__()
        self.community = community

    @pyqtSlot()
    def watch(self):
        logging.debug("Watching persons")
        for p in Person._instances.values():
            for func in [Person.membership,
                         Person.is_member,
                         Person.certifiers_of,
                         Person.certified_by]:
                if p.reload(func, self.community):
                    logging.debug("Change detected on {0} about {1}".format(p.pubkey,
                                                                            func.__name__))
                    self.person_changed.emit(p.pubkey)
        self.end_watching.emit()
